import axios from 'axios'
import {appConfig} from "./config"
import * as qs from "qs"
import dayjs from "dayjs"
import {ICourse, IJsonCourse, TChannel} from "./types"
import {JsonCourseList} from "./poll"
import axiosRetry from "axios-retry"

let sduAxios = axios.create({
    headers: {
        'Content-Type': 'application/x-www-form-urlencoded; charset=UTF-8',
        'Cookie': appConfig.cookie
    },
    baseURL: 'https://bkzhjx.wh.sdu.edu.cn/',
    timeout: 5,
    // maxRedirects: 0
})

axiosRetry(sduAxios, {
    retries: 2,
    shouldResetTimeout: true,
    retryCondition: (_error) => true,
})

export async function logAndNotifyUser(text: string) {
    console.log(text)
    await axios.post('https://qmsg.zendee.cn/send/' + appConfig.qmsgKey, qs.stringify({
        msg: text
    }), {
        headers: {
            'Content-Type': 'application/x-www-form-urlencoded'
        }
    })
}

export function sleep(ms: number) {
    return new Promise(resolve => setTimeout(resolve, ms))
}

export function getTimeNow() {
    return dayjs().format('hh:mm:ss A')
}

export function findJsonCourse(course: ICourse): IJsonCourse | undefined {
    return JsonCourseList[course.channel].find(single => single.kch == course.kch && parseInt(single.kxh) == course.kxh)
}

export async function acquireCourse(course: IJsonCourse, channel: TChannel): Promise<boolean> {
    if (channel == 'bx' || channel == 'xx') {

    } else {

    }
    return true
}

export async function exitCourse(course: IJsonCourse, channel: TChannel): Promise<boolean> {
    if (channel == 'bx' || channel == 'xx') {

    } else {

    }
    return true
}

export {sduAxios}
