import {JsonCourseList, poll} from "./poll"
import {appConfig} from "./config"
import {acquireProcess, monitProcess, replaceProcess} from "./actions"
import {sleep} from "./includes"

async function start() {
    console.log('开始启动轮询进程')
    poll()
    while (true) {
        let pollInitComplete = true
        for (let channel of appConfig.channels) {
            if (JsonCourseList[channel].length == 0) {
                pollInitComplete = false
            }
        }
        if (pollInitComplete) {
            break
        }
        await sleep(50)
    }
    console.log('轮询进程启动完毕')
    console.log('开始启动用户进程')
    for (let course of appConfig.monit?.list || []) {
        monitProcess(course)
    }
    for (let course of appConfig.acquire?.list || []) {
        acquireProcess(course)
    }
    if (appConfig.replace) {
        replaceProcess(appConfig.replace.list, appConfig.replace.exit)
    }
    console.log('用户进程启动完毕')
}

start()
